MODULE par;

(*
IMPORT WinBase;
*)
IMPORT Lib3, IO, SO, Config, Pak, ConSigs;
(*
IMPORT Ticks;
*)

PROCEDURE List();

  PROCEDURE Elm( i: Pak.TVldIdx );
  VAR
    r: Pak.TRef;
  BEGIN
    Pak.GetRef( i, r );
    IO.WrStr( r ); IO.WrLn();
  END Elm;

VAR
  n: Pak.TCnt;
  i: Pak.TVldIdx;
BEGIN
  n := Pak.Cnt();
  IF n = 0 THEN RETURN END;
  FOR i := 1 TO n DO Elm( i ) END;
END List;

PROCEDURE Table();

  PROCEDURE WrErr( VAR b: SO.TBuffer; e: Pak.TErrs );
  BEGIN
    IF Pak.eRng IN e THEN
      SO.WrChar( b, 'r' );
    ELSE
      SO.WrChar( b, '-' );
    END;
    IF Pak.eOvl IN e THEN
      SO.WrChar( b, 'o' );
    ELSE
      SO.WrChar( b, '-' );
    END;
  END WrErr;

  PROCEDURE Elm( i: Pak.TIdx );
  VAR
    b: SO.TBuffer;
    s: ARRAY [0..127] OF CHAR;
    r: Pak.TRef;
    e: Pak.TErrStr;
  BEGIN
    Pak.GetRef( i, r );
    Pak.MkErrStr( e, Pak.Err( i ) );
    SO.Init( b, s );
    SO.WrCard( b, i, 4 );
    SO.WrStr( b, ' ' );
    b.c.p := '0';
    SO.WrLngHex( b, Pak.Ofs( i ), 8 );
    SO.WrStr( b, ' ' );
    b.c.p := '0';
    SO.WrLngHex( b, Pak.Len( i ), 8 );
    SO.WrStr( b, ' ' );
    SO.WrStr( b, e );
    SO.WrStr( b, ' ' );
    SO.WrStr( b, r );
    IO.WrStr( s ); IO.WrLn();
  END Elm;

VAR
  n: Pak.TCnt;
  i: Pak.TIdx;
BEGIN
  n := Pak.Cnt();
  FOR i := 0 TO n DO Elm( i ) END;
END Table;


BEGIN
  CASE Config.data.act OF
  | Config.actList: List();
  | Config.actTable: Table();
  ELSE
    (* ??? *)
  END;
  Lib3.SetReturnCode( 0 );
END par.
